<?php
/**
* @version		IP2LocationCountryRedirectionBlocking.php  1.1.1
* @package		Joomla
* @copyright	Copyright (C) IP2Location 2017
* @license		GNU/GPL, see LICENSE.php
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * @package		Joomla
 * @subpackage	System
 */
class  plgSystemIP2LocationCountryRedirectionBlocking extends JPlugin {
	function onAfterDispatch(){
		$app = JFactory::getApplication();
		$plugin = JPluginHelper::getPlugin('system', 'IP2LocationCountryRedirectionBlocking');
		$params = new JRegistry();
		$params->loadString($plugin->params);
		
		$redirectopt = $params->get('redirectopt');
		$urlredirect = $params->get('urlredirect');

		if($this->isInPluginEditPage()){
			$db = JFactory::getDBO();
			$db->setQuery('SELECT extension_id FROM #__extensions WHERE folder ="system" AND element ="IP2LocationCountryRedirectionBlocking"');
			$plg = $db->loadObject();

			if($plg->extension_id == $app->input->get('extension_id')){
				// Looking for .BIN file in plugin  directory
				$files = scandir(JPATH_PLUGINS . '/system/IP2LocationCountryRedirectionBlocking');

				foreach($files as $file) {
					if (strtoupper(substr( $file, -4 )) == '.BIN') {
						if(!class_exists('IP2Location'))
							require(JPATH_PLUGINS . '/system/IP2LocationCountryRedirectionBlocking/ip2location.class.php');
						
						$ipl = new \IP2Location\Database((JPATH_PLUGINS . '/system/IP2LocationCountryRedirectionBlocking/' . $file), \IP2Location\Database::FILE_IO);
						$dbVersion = $ipl->getDatabaseVersion();
						$curdbVersion = str_replace(".", "-", $dbVersion);
						
						if(strtotime($curdbVersion) < strtotime('-2 months')){
							JFactory::getApplication()->enqueueMessage('Your IP2Location database is out-dated. Please download the latest version from http://lite.ip2location.com (Free) or http://www.ip2location.com (Commercial).', 'notice');
						}
						break;
					}
				}
			}
			
			if((strcmp($redirectopt, "1") == 0)){
				if(empty($urlredirect)){
					JFactory::getApplication()->enqueueMessage('Please provide a valid URL for redirection.', 'notice');
				}
				elseif(!filter_var($urlredirect, FILTER_VALIDATE_URL)){
					JFactory::getApplication()->enqueueMessage('Invalid URL provided.', 'notice');
				}
			} 
			
		}

		if(!$app->isSite()) return;
		$countries = $params->get('blocked_countries');

		if(is_array($countries)){
			if(in_array($this->getCountryCodeByIP(), $countries)){
				
				if((strcmp($redirectopt, "1") == 0) && (!empty($urlredirect)) && (filter_var($urlredirect, FILTER_VALIDATE_URL))){
					header("HTTP/1.1 301 Moved Permanently");
					header('Location: ' . $urlredirect);
					jexit();
				}
				else{
					header('HTTP/1.1 403 Forbidden');
					echo $params->get('message');
					jexit();
				}
			}
		}
	}

	private function isInPluginEditPage(){
		$app = JFactory::getApplication();

		if($app->input->get('option', '') == 'com_plugins' && ($app->input->get('view', '') == 'plugin' || $app->input->get('view', '') == ''))
			return true;

		return false;
	}

	function getIP() {
		if (isset($_SERVER['HTTP_X_FORWARDED_FOR']) && $_SERVER['HTTP_X_FORWARDED_FOR'] && (!isset($_SERVER['REMOTE_ADDR']) || preg_match('/^127\..*/i', trim($_SERVER['REMOTE_ADDR'])) || preg_match('/^172\.16.*/i', trim($_SERVER['REMOTE_ADDR'])) || preg_match('/^192\.168\.*/i', trim($_SERVER['REMOTE_ADDR'])) || preg_match('/^10\..*/i', trim($_SERVER['REMOTE_ADDR'])))) {
			if (strpos($_SERVER['HTTP_X_FORWARDED_FOR'], ',')) {
				$ips = explode(',', $_SERVER['HTTP_X_FORWARDED_FOR']);
				return $ips[0];
			}
			else
				return $_SERVER['HTTP_X_FORWARDED_FOR'];
		}
		return $_SERVER['REMOTE_ADDR'];
	}

    function getCountryCodeByIP(){
		if(!class_exists('IP2Location'))
			require(JPATH_PLUGINS . '/system/IP2LocationCountryRedirectionBlocking/ip2location.class.php');

		// Looking for .BIN file in plugin  directory
		$files = scandir(JPATH_PLUGINS . '/system/IP2LocationCountryRedirectionBlocking');

		foreach($files as $file) {
			if (strtoupper(substr( $file, -4 )) == '.BIN') {
				$geo = new \IP2Location\Database((JPATH_PLUGINS . '/system/IP2LocationCountryRedirectionBlocking/' . $file), \IP2Location\Database::FILE_IO);

				// Get geolocation by IP address.
				$response = $geo->lookup($this->getIP(), \IP2Location\Database::ALL);

				return $response['countryCode'];
			}
		}

		return;
    }
}
